"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var reducer_utils_1 = require("./reducer.utils");

exports.toMapKeyMap = function (getKey) {
  return function (agr, value, index, array) {
    var key = reducer_utils_1.valid(getKey(value));

    if (agr.containsKey(key)) {
      throw new Error("Key: \"".concat(key, "\" has duplicates"));
    }

    agr.put(key, value);
    return reducer_utils_1.isLastElement(array, index) ? reducer_utils_1.finalizeMap(agr) : agr;
  };
};

exports.toMapAndValue = function (getKey, getValue) {
  return function (agr, value, index, array) {
    var key = reducer_utils_1.valid(getKey(value));

    if (agr.containsKey(key)) {
      throw new Error("Key: \"".concat(key, "\" has duplicates"));
    }

    agr.put(key, getValue(value));
    return reducer_utils_1.isLastElement(array, index) ? reducer_utils_1.finalizeMap(agr) : agr;
  };
};