import { ImmutableMap } from './ImmutableMap';
import { MethodMap, Entry } from './MethodMap';
export declare class ImmutableBuilder<T> implements MethodMap<T> {
    private readonly map;
    keys(): string[];
    values(): T[];
    containsKey(key: string): boolean;
    containsValue(): boolean;
    entries(): Entry<T>[];
    size(): number;
    toObject(): {
        [keyof: string]: T;
    };
    put(key: string, value: T): T | undefined;
    get(key: string): T | undefined;
    buildMap(): ImmutableMap<T>;
    buildObject(): Readonly<{
        [keyof: string]: T;
    }>;
}
