import { AlwaysArray, Getter } from '../types';
export declare class Optional<T> {
    private readonly value?;
    constructor(value?: T | undefined);
    orElse(value: T): T;
    orElseGet(supplier: () => T): T;
    orElseThrow(errorMessage?: string): T | never;
    isPresent(): boolean;
    isAbsent(): boolean;
    ifPresent(consumer: () => void): void;
    ifAbsent(consumer: () => void): void;
    get(): NonNullable<T>;
    map<R>(mapper: Getter<T, R>): Optional<NonNullable<R>>;
    filter(predicate: (value: T) => boolean): Optional<T>;
    toArray(): AlwaysArray<T>;
}
export declare const optional: <T>(value?: T | undefined) => Optional<T>;
