"use strict";

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

Object.defineProperty(exports, "__esModule", {
  value: true
});

var ToArray_1 = require("../internal/ToArray");

var Optional =
/*#__PURE__*/
function () {
  function Optional(value) {
    _classCallCheck(this, Optional);

    this.value = value;
  }

  _createClass(Optional, [{
    key: "orElse",
    value: function orElse(value) {
      return this.isPresent() ? this.value : value;
    }
  }, {
    key: "orElseGet",
    value: function orElseGet(supplier) {
      return this.isPresent() ? this.value : supplier();
    }
  }, {
    key: "orElseThrow",
    value: function orElseThrow(errorMessage) {
      if (!this.isPresent()) {
        throw new Error(errorMessage);
      }

      return this.value;
    }
  }, {
    key: "isPresent",
    value: function isPresent() {
      return this.value != undefined;
    }
  }, {
    key: "isAbsent",
    value: function isAbsent() {
      return this.value == undefined;
    }
  }, {
    key: "ifPresent",
    value: function ifPresent(consumer) {
      if (this.isPresent()) {
        consumer();
      }
    }
  }, {
    key: "ifAbsent",
    value: function ifAbsent(consumer) {
      if (this.isAbsent()) {
        consumer();
      }
    }
  }, {
    key: "get",
    value: function get() {
      if (this.value == undefined) {
        throw new Error('Value is not defined');
      }

      return this.value;
    }
  }, {
    key: "map",
    value: function map(mapper) {
      return this.isPresent() ? new Optional(mapper(this.value)) : new Optional();
    }
  }, {
    key: "filter",
    value: function filter(predicate) {
      if (this.isPresent()) {
        return predicate(this.value) ? this : new Optional();
      }

      return new Optional();
    }
  }, {
    key: "toArray",
    value: function toArray() {
      return ToArray_1.toArray(this.value);
    }
  }]);

  return Optional;
}();

exports.Optional = Optional;

exports.optional = function (value) {
  return new Optional(value);
};